/* /////////////////////////////////////////////////////////////////////////////
 * File:        winstl_last_error_scope.h (formerly MWTErrScp.h, ::SynesisWin)
 *
 * Purpose:     Win32 LastError scoping class.
 *
 * Created:     27th November 1998
 * Updated:     30th May 2004
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Source License)
 *
 *              Copyright (C) 2002-2004, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/winstl
 *                          http://www.winstl.org/
 *
 *              email:      submissions@winstl.org  for submissions
 *                          admin@winstl.org        for other enquiries
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (iv) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


/// \file winstl_last_error_scope.h
///
/// Win32 LastError scoping class.

#ifndef WINSTL_INCL_H_WINSTL_LAST_ERROR_SCOPE
#define WINSTL_INCL_H_WINSTL_LAST_ERROR_SCOPE

#ifndef __STLSOFT_DOCUMENTATION_SKIP_SECTION
# define WINSTL_VER_H_WINSTL_LAST_ERROR_SCOPE_MAJOR     1
# define WINSTL_VER_H_WINSTL_LAST_ERROR_SCOPE_MINOR     0
# define WINSTL_VER_H_WINSTL_LAST_ERROR_SCOPE_REVISION  3
# define WINSTL_VER_H_WINSTL_LAST_ERROR_SCOPE_EDIT      3
#endif /* !__STLSOFT_DOCUMENTATION_SKIP_SECTION */

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#ifndef WINSTL_INCL_H_WINSTL_ERROR_SCOPE
# include "winstl_error_scope.h"        // winstl::last_error_scope
#endif /* !WINSTL_INCL_H_WINSTL_ERROR_SCOPE */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* WINSTL_INCL_H_WINSTL_LAST_ERROR_SCOPE */

/* ////////////////////////////////////////////////////////////////////////// */
